class Fixnum
  def ord() self end
end

def resolution(aviname)
  data = open(aviname, "rb").read(10240)
  pos = data.index('avih')
  w = data[pos+40].ord + (data[pos+41].ord << 8)
  h = data[pos+44].ord + (data[pos+45].ord << 8)
  w = 460 if w < 460
  h = 64 if h < 64
  [w, h]
end

if ARGV.size < 2
  puts "usage: mkpage urlpath avifile [full]"
  puts "example: mkpage http://localhost/ browsing.avi full"
  exit
end

w, h = resolution(ARGV[1]) 
suffix = ARGV.size > 2 ? "_full" : ""

print <<EOF
<html>
<head>
<title>ScreenPressor web-player alpha</title>
</head>
<body bgcolor="#f0f0f0">
This is a demo of Flash-based player for 
<a href="http://www.infognition.com/ScreenPressor/">ScreenPressor</a> lossless video codec.
<p>
<div style="height:#{h}">
 <object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" id="player" width="#{w}" height="#{h}">
    <param name="movie" value="screenpressor#{suffix}.swf">
    <param name="FlashVars" value="fname=#{ARGV[0]}#{ARGV[1]}">
    <param name="allowFullScreen" value="true"/>
    <param name="allowScriptAccess" value="always" />
    <embed type="application/x-shockwave-flash" src="screenpressor#{suffix}.swf"
      width="#{w}" height="#{h}" flashVars="fname=#{ARGV[0]}#{ARGV[1]}" 
      allowFullScreen="true" allowScriptAccess="always" name="player">
    </embed>
</object>
</div>
<p>
Controls:
<div style="margin-left:15">
|&lt;  home <br>
&lt;&lt; previous key frame <br>
&lt;| one frame back <br>
&gt;  play <br> 
|&gt; one frame forward <br> 
&gt;&gt; next key frame
</div>
</body>
</html>
EOF
